package com.fr.plugin.http;

import com.fr.decision.fun.impl.BaseHttpHandler;
import com.fr.json.JSONObject;
import com.fr.plugin.MyDecisionDBAccessProvider;
import com.fr.plugin.dao.MyDao_IPRange;
import com.fr.plugin.dao.MyDao_UserToken;
import com.fr.plugin.entity.MyIPRange;
import com.fr.plugin.entity.MyUserToken;
import com.fr.stable.StringUtils;
import com.fr.stable.db.accessor.DBAccessor;
import com.fr.stable.query.QueryFactory;
import com.fr.stable.query.condition.QueryCondition;
import com.fr.stable.query.restriction.RestrictionFactory;
import com.fr.swift.source.core.MD5Utils;
import com.fr.third.jgroups.util.UUID;
import com.fr.third.springframework.web.bind.annotation.RequestMethod;
import com.fr.web.utils.WebUtils;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Date;
import java.util.List;

public class getToken extends BaseHttpHandler
{
    @Override
    public RequestMethod getMethod()
    {
        return null;
    }

    @Override
    public String getPath()
    {
        return "/getTokenURL";
    }

    @Override
    public boolean isPublic()
    {
        return true;
    }

    @Override
    public void handle(HttpServletRequest req, HttpServletResponse res) throws Exception
    {
        try
        {
            String userName = WebUtils.getHTTPRequestParameter(req,"userName");
            String t = String.valueOf(new Date().getTime());

            DBAccessor dbAccessor2 = MyDecisionDBAccessProvider.getDbAccessor();

            if(!StringUtils.isNotBlank(userName))
            {
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("msg","userName Cannot be empty!");
                jsonObject.put("code",100);
                WebUtils.printAsJSON(res, jsonObject);
                return;
            }

            List<MyUserToken> entityList = dbAccessor2.runQueryAction(daoContext ->
            {
                QueryCondition queryCondition = QueryFactory.create();
                queryCondition.addRestriction(RestrictionFactory.eq("userName", userName));
                return daoContext.getDAO(MyDao_UserToken.class).find(queryCondition);
            });

            if(entityList.size() == 0)
            {
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("msg","用户 " + userName + " 不存在");
                jsonObject.put("code",100);
                WebUtils.printAsJSON(res, jsonObject);
                return;
            }
            String userTokenKey = entityList.get(0).getUserToken();
            String md5 = MD5Utils.getMD5String(new String[]{userName, t, userTokenKey});

            JSONObject jsonObject = new JSONObject();
            jsonObject.put("用户:", "\"" + userName + "\"");
            jsonObject.put("URL:","http://localhost:8075/webroot/decision?token="+md5+"&userName="+userName+"&t="+t);
            jsonObject.put("提示:","30秒后过期！");
            WebUtils.printAsJSON(res, jsonObject);
        }catch (Exception e)
        {
            e.printStackTrace();
            WebUtils.printAsString(res, e.getCause().getMessage().split(";")[0]);
        }
    }
}
