!(function()
{
    BI.config("dec.constant.management.navigation", function (items)
    {
        items.push(
            {
                value: "userToken",  //地址栏显示的hash值
                id: "IPToken_1",  //与OptionProvider的ID一致
                text: BI.i18nText("Token关联"),  //显示名称
                cardType: "dec.management.tokenConfig",  //组件的shortcut
                cls: "management-directory-font"  //图标类名
            });
        return items;
    });

    function resolvePath(path, isPublic)
    {
        if (!path || path[0] !== '/')
        {
            path = '/' + path;
        }
        return isPublic === true ? '/plugin/public/com.fr.plugin.test.IPFilter3' + path : '/plugin/private/com.fr.plugin.test.IPFilter3' + path;
    }

    var ipConfig = BI.inherit(BI.Widget,
        {
            props: { baseCls: "tokenConfig"},
            render: function ()
            {
                var self = this;
                return {
                    type: "bi.absolute",
                    items: [
                        {
                            el: {
                                type: "bi.button",
                                text: "添加",
                                handler: function ()
                                {
                                    var id = "addUerPane";
                                    var that = this;
                                    BI.Popovers.create(id,
                                        {
                                            type: "bi.bar_popover",
                                            header: "User-Token关联",
                                            size: "small",
                                            body:
                                                {
                                                    type: "bi.add.userTokenOrIp",
                                                    cType: "token",
                                                    ref: function (e)
                                                    {
                                                        that.userIpPane = e;
                                                    }
                                                },
                                            listeners: [
                                                {
                                                    eventName: "EVENT_CANCEL",
                                                    action: function ()
                                                    {
                                                        BI.Msg.toast("点了个取消~");
                                                    }
                                                },
                                                {
                                                    eventName: "EVENT_CONFIRM",
                                                    action: function ()
                                                    {
                                                        var params = that.userIpPane.getValue();
                                                        console.info(params);
                                                        Dec.reqPost(resolvePath("/API_ADD", true),
                                                            {
                                                                userName: params.userName,
                                                                userToken: params.params2
                                                            }, function ()
                                                            {
                                                                BI.Msg.toast("保存成功~");
                                                                self.tableRef.reload();
                                                            });
                                                    }
                                                }]
                                        }).open(id);
                                }
                            },
                            top: 0,
                            left: 0
                        },
                        {
                            el: {
                                type: "bi.button",
                                text: "刷新",
                                handler: function ()
                                {
                                    self.tableRef.reload();
                                }
                            },
                            top: 0,
                            left: 100
                        },
                        {
                            el: {
                                type: "dec.management.iptoken.table",
                                tableType: "tokenTable",
                                ref: function (e)
                                {
                                    self.tableRef = e;
                                }
                            },
                            top: 40,
                            left: 0,
                            right: 0,
                            bottom: 0
                        }]
                }
            }
        });
    BI.shortcut("dec.management.tokenConfig", ipConfig)
}());